PrettyPrint - Crystal 1.11.2

# class PrettyPrint

- PrettyPrint
- Reference
- Object

##
Overview

This class implements a pretty printing algorithm. It finds line breaks and nice indentations for grouped structure.

###
References

- Ruby's prettyprint.rb
- Christian Lindig, Strictly Pretty, March 2000
- Philip Wadler, A prettier printer, March 1998

##
Defined in:

pretty_print.cr

##
Constructors

- .new(output : IO, maxwidth : Int32 = 79, newline : String = "\n", indent : Int32 = 0)

  Creates a new pretty printer that will write to the given output and be capped at maxwidth.

##
Class Method Summary

- .format(obj, io : IO, width : Int32, newline = "\n", indent = 0)

  Pretty prints obj into io with the given width as a limit and starting with the given indentation.

- .format(io : IO, width : Int32, newline = "\n", indent = 0, &)

  Creates a pretty printer and yields it to the block, appending any output to the given io.

##
Instance Method Summary

- #breakable(sep = " ") : Nil

  Appends an element that can turn into a newline if necessary.

- #comma : Nil

  Same as:

- #fill_breakable(sep = " ") : Nil

  Similar to `#breakable` except the decision to break or not is determined individually.

- #flush : Nil

  Outputs any buffered data.

- #group(indent = 0, open_obj = "", close_obj = "", &)

  Creates a group of objects.

- #list(left, elements, right, &) : Nil

  Appends a list of elements surrounded by left and right and separated by commas, yielding each element to the given block.

- #list(left, elements, right) : Nil

  Appends a list of elements surrounded by left and right and separated by commas.

- #nest(indent = 1, &)

  Increases the indentation for breakables inside the current group.

- #surround(left, right, left_break = "", right_break = "", &) : Nil

  Appends a group that is surrounded by the given left and right objects, and optionally is surrounded by the given breakable objects.

- #text(obj) : Nil

  Appends a text element.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(output : IO, maxwidth : Int32 = 79, newline : String = "\n", indent : Int32 = 0) #

Creates a new pretty printer that will write to the given output and be capped at maxwidth.

##
Class Method Detail

def self.format(obj, io : IO, width : Int32, newline = "\n", indent = 0) #

Pretty prints obj into io with the given width as a limit and starting with the given indentation.

def self.format(io : IO, width : Int32, newline = "\n", indent = 0, &) #

Creates a pretty printer and yields it to the block, appending any output to the given io.

##
Instance Method Detail

def breakable(sep = " ") : Nil #

Appends an element that can turn into a newline if necessary.

def comma : Nil #

Same as:

    text ","
    breakable

def fill_breakable(sep = " ") : Nil #

Similar to `#breakable` except the decision to break or not is determined individually.

def flush : Nil #

Outputs any buffered data.

def group(indent = 0, open_obj = "", close_obj = "", &) #

Creates a group of objects. Inside a group all breakable objects are either turned into newlines or are output as is, depending on the available width.

def list(left, elements, right, &) : Nil #

Appends a list of elements surrounded by left and right and separated by commas, yielding each element to the given block.

def list(left, elements, right) : Nil #

Appends a list of elements surrounded by left and right and separated by commas.

def nest(indent = 1, &) #

Increases the indentation for breakables inside the current group.

def surround(left, right, left_break = "", right_break = "", &) : Nil #

Appends a group that is surrounded by the given left and right objects, and optionally is surrounded by the given breakable objects.

def text(obj) : Nil #

Appends a text element.